#include <stdio.h>
//#include "SDL.h"

#include "gba.h"
#include "globals.h"
#include "gbGlobals.h"
#include "system.h"
#include "util.h"
#include "sound.h"
#include "menu.h"

#ifdef _arch_dreamcast
#include <kos.h>
/* romdisk */
extern uint8 romdisk[];
KOS_INIT_ROMDISK(romdisk);
#endif
 
extern int vba32();
extern int autoFrameSkip;
extern int throttle;
extern int autoFire;
extern int vba32_rom_type;

//extern void SetCPUSpeed (const long speed, const int mult, const int flags);

void menuValues(void)
{
	if (mainMenu_frameskip >= 0)
	{ 
		systemFrameSkip = mainMenu_frameskip;
		frameSkip = mainMenu_frameskip;
		gbFrameSkip = mainMenu_frameskip;
		autoFrameSkip = 9;
	}
	else
	{
		if (vba32_rom_type==IMAGE_GBA)
		{
			systemFrameSkip = 9;
			frameSkip = 9;
			gbFrameSkip = 9;
		}
		else
		{
			systemFrameSkip = 0;
			frameSkip = 0;
			gbFrameSkip = 0;
		}
		autoFrameSkip = 1;
	}

	if (mainMenu_sound)
		soundOffFlag=0;
	else
		soundOffFlag=-1;

	throttle = mainMenu_throttle * 5;
/*
	switch(mainMenu_speed)
	{
		case 100:
			//SetCPUSpeed(99000000, 0x3a002, 2);
			break;
		case 120:
//			//SetCPUSpeed();
			break;
		case 133:
			//SetCPUSpeed(132000000, 0x3a011, 3);
			break;
		case 156:
			//SetCPUSpeed(156000000, 0x2c001, 3);
			break;
		case 166:
			//SetCPUSpeed(165000000, 0x2f001, 3);
			break;
	}
*/
	if (controlMenu_autoA)
		autoFire=1;
	else
		autoFire=0;
	if (controlMenu_autoB)
		autoFire+=2;

	emulating=1;
}

void mainMenu(void)
{
	int ret;
//	SDL_Quit();
//    SDL_QuitSubSystem(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK);

	//init_text(0);

	ret=run_mainMenu();

	quit_text();

	if (ret==1){
		emulating=0;
	}
	else
	{
		emulating=1;
		menuValues();
//		SDL_Quit();
//		if(!soundOffFlag)
//		{
//			SDL_Init(SDL_INIT_VIDEO);
//			//systemSoundInit();
//		}
//		else
//			SDL_Init(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK|SDL_INIT_TIMER);
	}
}

static inline void drawError(char *msg)
{
	int i;
	for(i=0;i<40;i++)
	{
		text_draw_background();
		text_draw_window(64,120,240,32,"--- ERROR ---");
		write_text(9,16,msg);
//		SDL_Flip(text_screen);
#ifndef GP32
//		SDL_Delay(20);
#endif
	}
}

static inline void drawLoading()
{
	int i;
	for(i=0;i<5;i++)
	{
		text_draw_background();
		text_draw_window(96,64,140,32,"-------");
		write_text(14,9,"Loading...");
//		SDL_Flip(text_screen);
#ifndef GP32
//		SDL_Delay(20);
#endif
	}
}




#ifdef _arch_dreamcast
int main(int argc, char *argv[])  
#else
void WinMain(void *arg)
#endif
{
  vid_set_mode(DM_320x240, PM_RGB565);
  vid_clear(0,0,0);

  pvr_setup();
  
	int ret=2,splash=1;
	//dbgio_dev_select("vmulog");
    //vmulog_init();

	while(1)
	{
		init_text(splash);
		switch(ret)
		{
			case 1:
			case 2:
				break;
			case -5:
				drawError("Unknown file type");
				break;
			case -6:
				drawError("Failed to load file");
				break;
			case -8:
				drawError("Failed to set video mode");
				break;
			default:
				drawError("No error");
		}
		while(ret!=1)
			ret=run_mainMenu();
		drawLoading();
		quit_text();
//		if(mainMenu_sound)
////			SDL_Init(SDL_INIT_VIDEO);//|SDL_INIT_JOYSTICK);
//		else
//			SDL_Init(SDL_INIT_VIDEO);//|SDL_INIT_JOYSTICK);
		ret=vba32();
		splash=1;
//		SDL_Quit();
	}

}
