#ifndef MENU_H
#define MENU_H
#include<stdio.h>
#include<SDL/SDL.h>

extern SDL_Surface *text_screen;

extern int mainMenu_throttle;
extern int mainMenu_frameskip;
extern int mainMenu_sound;
//extern int mainMenu_speed;
extern int controlMenu_autoA;
extern int controlMenu_autoB;

void text_draw_background();
void init_text(int splash);
void quit_text();
void write_text(int x, int y, char * str);
void write_text_inv(int x, int y, char * str);
void write_centered_text(int y, char * str);
void write_num(int x, int y, int v);
void write_num_inv(int x, int y, int v);
void text_draw_window(int x, int y, int w, int h, char *title);
void text_draw_menu_msg();

int run_mainMenu();
int run_menuLoad();
int run_menuGame();
int run_menuControl();

static int num_joys;//=0;
static SDL_Joystick *joys[4];
#define JOY_UP(num) ((num_joys>num && SDL_JoystickGetAxis(joys[num], 1)<-joyval))
#define JOY_DOWN(num) ((num_joys>num && SDL_JoystickGetAxis(joys[num], 1)>joyval))
#define JOY_RIGHT(num) ((num_joys>num && SDL_JoystickGetAxis(joys[num], 0)>joyval))
#define JOY_LEFT(num) ((num_joys>num && SDL_JoystickGetAxis(joys[num], 0)<-joyval))
#define JOY_A(num) (num_joys>num && SDL_JoystickGetButton(joys[num], 0))
#define JOY_B(num) (num_joys>num && SDL_JoystickGetButton(joys[num], 1))
#define JOY_X(num) (num_joys>num && SDL_JoystickGetButton(joys[num], 2))
#define JOY_Y(num) (num_joys>num && SDL_JoystickGetButton(joys[num], 3))
#define JOY_START(num) (num_joys>num && SDL_JoystickGetButton(joys[num], 4))
#define JOY_HATUP(num) (num_joys>num && (SDL_JoystickGetHat(joys[num], 0) & SDL_HAT_UP))
#define JOY_HATDOWN(num) (num_joys>num && (SDL_JoystickGetHat(joys[num], 0) & SDL_HAT_DOWN))
#define JOY_HATRIGHT(num) (num_joys>num && (SDL_JoystickGetHat(joys[num], 0) & SDL_HAT_RIGHT))
#define JOY_HATLEFT(num) (num_joys>num && (SDL_JoystickGetHat(joys[num], 0) & SDL_HAT_LEFT))


#endif


