#include "menu.h"


static char *text_str_control_title="Control Menu";
static char *text_str_control_autoA="Autofire A";
static char *text_str_control_autoB="Autofire B";
static char *text_str_control_enabled="Enabled";
static char *text_str_control_disabled="Disabled";
static char *text_str_control_separator="----------------------";
static char *text_str_control_back="Back";

extern int num_joys;//=0;
extern SDL_Joystick *joys[4]; 

#define WINDOW_X 8
#define WINDOW_Y 9 

int controlMenu_autoA=0;
int controlMenu_autoB=0;

static inline void draw_controlMenu(int c)
{
	static int b=0;
	int bb=(b%6)/3;
	int i;

	text_draw_background();
	text_draw_window(60,64,210,150,text_str_control_title);

	write_text(WINDOW_X,WINDOW_Y,text_str_control_separator);
	write_text(WINDOW_X,WINDOW_Y+1,text_str_control_autoA);
	if ((controlMenu_autoA)&&((c!=0)||(bb)))
		write_text_inv(WINDOW_X+2,WINDOW_Y+3,text_str_control_enabled);
	else
		write_text(WINDOW_X+2,WINDOW_Y+3,text_str_control_enabled);

	if ((!controlMenu_autoA)&&((c!=0)||(bb)))
		write_text_inv(WINDOW_X+14,WINDOW_Y+3,text_str_control_disabled);
	else
		write_text(WINDOW_X+14,WINDOW_Y+3,text_str_control_disabled);
	write_text(WINDOW_X,WINDOW_Y+4,text_str_control_separator);

	write_text(WINDOW_X,WINDOW_Y+6,text_str_control_separator);
	write_text(WINDOW_X,WINDOW_Y+7,text_str_control_autoB);
	if ((controlMenu_autoB)&&((c!=1)||(bb)))
		write_text_inv(WINDOW_X+2,WINDOW_Y+9,text_str_control_enabled);
	else
		write_text(WINDOW_X+2,WINDOW_Y+9,text_str_control_enabled);

	if ((!controlMenu_autoB)&&((c!=1)||(bb)))
		write_text_inv(WINDOW_X+14,WINDOW_Y+9,text_str_control_disabled);
	else
		write_text(WINDOW_X+14,WINDOW_Y+9,text_str_control_disabled);
	write_text(WINDOW_X,WINDOW_Y+10,text_str_control_separator);
	
	write_text(WINDOW_X,WINDOW_Y+13,text_str_control_separator);
	if ((c!=2)||(bb))
		write_text(WINDOW_X,WINDOW_Y+14,text_str_control_back);
	else
		write_text_inv(WINDOW_X,WINDOW_Y+14,text_str_control_back);
	write_text(WINDOW_X,WINDOW_Y+15,text_str_control_separator);

	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(50);
#endif
	b++;
}

static inline int key_controlMenu(int *cp)
{
	int c=(*cp);
	int end=0;
	int left=0, right=0, up=0, down=0, hit0=0, hit1=0;
	int getleft,getright,getup,getdown,getA,getStart=0;
	int joyleft,joyright,joyup,joydown,joyA,joyStart=0;		
	SDL_Event event;

	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
			end=-1;
		else
		if (event.type == SDL_KEYDOWN)
		{
			switch(event.key.keysym.sym)
			{
				case SDLK_RIGHT: right=1; break;
				case SDLK_LEFT: left=1; break;
				case SDLK_UP: up=1; break;
				case SDLK_DOWN: down=1; break;
				case SDLK_LCTRL: hit0=1; break;
				case SDLK_LALT: hit1=1; break;
				default: 
                break;				
			}
		}
  		else
    	if (event.type == SDL_JOYHATMOTION)
     	{
     		joyup=JOY_HATUP(0);
     		joydown=JOY_HATDOWN(0);
     		joyleft=JOY_HATLEFT(0);
     		joyright=JOY_HATRIGHT(0);
      		if (joyup )//&& !getup)
			{ 		
				up=1;
			}
			getup=joyup;
      		if (joydown )//&& !getdown)
			{ 		
				down=1;
			}
			getdown=joydown;			
      		if (joyleft )//&& !getleft)
			{ 		
				left=1;
			}
			getleft=joyleft;				
      		if (joyright )//&& !getright)
			{ 		
				right=1;
			}
			getright=joyright;		
  		}
  		else
    	if (event.type == SDL_JOYBUTTONDOWN || event.type == SDL_JOYBUTTONUP)
     	{    		
     		joyA=JOY_A(0);
     		joyStart=JOY_START(0);
     		
      		if (joyA )//&& !getA)
			{ 		
				hit0=1;
			}
			getA=joyA;	    
      		if (joyStart )//&& !getStart)
			{ 		
				hit1=1;
			}
			getStart=joyStart; 	
		}
			if ((hit1) || (hit0 && c==2))
				end=-1;
			else if (up)
			{
				if (c)
					c--;
				else
					c=2;
			}
			else if (down)
			{
				c=(c+1)%3;
			}
			else if (left || right || hit0)
			{
				switch(c)
				{
					case 0:
						controlMenu_autoA=~controlMenu_autoA;
						break;
					case 1:
						controlMenu_autoB=~controlMenu_autoB;
						break;
				}
			}
		
	}

	(*cp)=c;
	return end;
}

static inline void raise_controlMenu()
{
	int i;

	text_draw_background();
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(20);
#endif
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(60,(12-i)*24,210,150,text_str_control_title);
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(10);
#endif
	}
}

static inline void unraise_controlMenu()
{
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(60,(12-i)*24,210,150,text_str_control_title);
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(10);
#endif
	}
	text_draw_background();
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(20);
#endif
}


int run_menuControl()
{
	int end,c=0;
	num_joys = SDL_NumJoysticks();
	joys[0] = SDL_JoystickOpen(0);
	raise_controlMenu();
	end=0;
	while(!end)
	{
		draw_controlMenu(c);
		end=key_controlMenu(&c);
	}
	unraise_controlMenu();

	return -1;
}
