#include "menu.h"

extern void (*emuReset)();
extern void sdlWriteState(int num);
extern void sdlReadState(int num);

char *text_str_game_title="Game Menu";
char *text_str_game_back="Back";
char *text_str_game_save="Save State";
char *text_str_game_load="Load State";
char *text_str_game_reset="Reset GameBoy";
char *text_str_game_separator="----------------------";

extern int num_joys;//=0;
extern SDL_Joystick *joys[4];

#define WINDOW_X 8
#define WINDOW_Y 7

int gameMenu_state=0;
int gameMenu_case=-1;

enum { GAME_MENU_CASE_SAVE, GAME_MENU_CASE_LOAD, GAME_MENU_CASE_RESET, GAME_MENU_CASE_CANCEL };

static inline void draw_gameMenu(int c)
{
	static int b=0;
	int bb=(b%6)/3;
	int i;

	text_draw_background();
	text_draw_window(60,48,210,170,text_str_game_title);
	write_text(WINDOW_X,WINDOW_Y,text_str_game_separator);
	write_text(WINDOW_X,WINDOW_Y+1,text_str_game_save);
	for(i=0;i<10;i++)
		if ((c==0)&&(bb)&&(gameMenu_state==i))
			write_num_inv(WINDOW_X+(i*2),WINDOW_Y+3,i);
		else
			write_num(WINDOW_X+(i*2),WINDOW_Y+3,i);
	write_text(WINDOW_X,WINDOW_Y+4,text_str_game_separator);


	write_text(WINDOW_X,WINDOW_Y+6,text_str_game_separator);
	write_text(WINDOW_X,WINDOW_Y+7,text_str_game_load);
	for(i=0;i<10;i++)
		if ((c==1)&&(bb)&&(gameMenu_state==i))
			write_num_inv(WINDOW_X+(i*2),WINDOW_Y+9,i);
		else
			write_num(WINDOW_X+(i*2),WINDOW_Y+9,i);
	write_text(WINDOW_X,WINDOW_Y+10,text_str_game_separator);

	write_text(WINDOW_X,WINDOW_Y+12,text_str_game_separator);
	if ((c==2)&&(bb))
		write_text_inv(WINDOW_X,WINDOW_Y+13,text_str_game_reset);
	else
		write_text(WINDOW_X,WINDOW_Y+13,text_str_game_reset);
	write_text(WINDOW_X,WINDOW_Y+14,text_str_game_separator);
	
	write_text(WINDOW_X,WINDOW_Y+16,text_str_game_separator);
	if ((c==3)&&(bb))
		write_text_inv(WINDOW_X,WINDOW_Y+17,text_str_game_back);
	else
		write_text(WINDOW_X,WINDOW_Y+17,text_str_game_back);
	write_text(WINDOW_X,WINDOW_Y+18,text_str_game_separator);
	
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(50);
#endif
	b++;
}

static inline int key_gameMenu(int *cp)
{
	int c=(*cp);
	int end=0;
	int left=0, right=0, up=0, down=0, hit0=0, hit1=0;
	int getleft,getright,getup,getdown,getA,getStart=0;
	int joyleft,joyright,joyup,joydown,joyA,joyStart=0;	
	SDL_Event event;

	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
			end=-1;
		else
		if (event.type == SDL_KEYDOWN)
		{
			switch(event.key.keysym.sym)
			{
				case SDLK_RIGHT: right=1; break;
				case SDLK_LEFT: left=1; break;
				case SDLK_UP: up=1; break;
				case SDLK_DOWN: down=1; break;
				case SDLK_LCTRL: hit0=1; break;
				case SDLK_LALT: hit1=1; break;
				default: 
                break;
			}
		}
  		else
    	if (event.type == SDL_JOYHATMOTION)
     	{
     		joyup=JOY_HATUP(0);
     		joydown=JOY_HATDOWN(0);
     		joyleft=JOY_HATLEFT(0);
     		joyright=JOY_HATRIGHT(0);
      		if (joyup && !getup)
			{ 		
				up=1;
			}
			getup=joyup;
      		if (joydown && !getdown)
			{ 		
				down=1;
			}
			getdown=joydown;			
      		if (joyleft && !getleft)
			{ 		
				left=1;
			}
			getleft=joyleft;				
      		if (joyright && !getright)
			{ 		
				right=1;
			}
			getright=joyright;		
  		}
  		else
    	if (event.type == SDL_JOYHATMOTION)
     	{
     		joyup=JOY_HATUP(0);
     		joydown=JOY_HATDOWN(0);
     		joyleft=JOY_HATLEFT(0);
     		joyright=JOY_HATRIGHT(0);
      		if (joyup )//&& !getup)
			{ 		
				up=1;
			}
			getup=joyup;
      		if (joydown )//&& !getdown)
			{ 		
				down=1;
			}
			getdown=joydown;			
      		if (joyleft )//&& !getleft)
			{ 		
				left=1;
			}
			getleft=joyleft;				
      		if (joyright )//&& !getright)
			{ 		
				right=1;
			}
			getright=joyright;		
  		}
  		else
    	if (event.type == SDL_JOYBUTTONDOWN || event.type == SDL_JOYBUTTONUP)
     	{    		
     		joyA=JOY_A(0);
     		joyStart=JOY_START(0);
     		
      		if (joyA )//&& !getA)
			{ 		
				hit0=1;
			}
			getA=joyA;	    
      		if (joyStart )//&& !getStart)
			{ 		
				hit1=1;
			}
			getStart=joyStart; 	
		}
			if (hit1)
			{
				gameMenu_case=GAME_MENU_CASE_CANCEL;
				end=1;
			}
			else if (up)
			{
				if (c>0) c=(c-1)%4;
				else c=3;
			}
			else if (down)
			{
				c=(c+1)%4;
			}
			else if (hit0)
			{
				gameMenu_case=c;
				end=1;
			}
			else if (left)
			{
				if (gameMenu_state>0)
					gameMenu_state=(gameMenu_state-1)%10;
				else 
					gameMenu_state=9;
			}
			else if (right)
			{
				gameMenu_state=(gameMenu_state+1)%10;
			}
		
	}

	(*cp)=c;
	return end;
}

static inline void raise_gameMenu()
{
	int i;

	text_draw_background();
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(20);
#endif
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(60,(11-i)*24,210,170,text_str_game_title);
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(10);
#endif
	}
}

static inline void unraise_gameMenu()
{
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(60,(11-i)*24,210,170,text_str_game_title);
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(10);
#endif
	}
	text_draw_background();
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(20);
#endif
}

static inline void drawLoading()
{
	int i;
	for(i=0;i<5;i++)
	{
		text_draw_background();
		text_draw_window(96,64,140,32,"-------");
		write_text(14,9,"Loading State");
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(20);
#endif
	}
}

static inline void drawSaving()
{
	int i;
	for(i=0;i<5;i++)
	{
		text_draw_background();
		text_draw_window(96,64,140,32,"-------");
		write_text(14,9,"Saving State");
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(20);
#endif
	}
}

int run_menuGame()
{
	int ret=0,end,c=0;
	num_joys = SDL_NumJoysticks();
	joys[0] = SDL_JoystickOpen(0);
	gameMenu_case=-1;
	while(gameMenu_case<0)
	{
		raise_gameMenu();
		end=0;
		while(!end)
		{
			draw_gameMenu(c);
			end=key_gameMenu(&c);
		}
		unraise_gameMenu();
		switch(gameMenu_case)
		{
			case GAME_MENU_CASE_LOAD:
				drawLoading();
				sdlReadState(gameMenu_state);
				break;
			case GAME_MENU_CASE_SAVE:
				drawSaving();
				sdlWriteState(gameMenu_state);
				break;
			case GAME_MENU_CASE_RESET:
				emuReset();
				break;
			default:
				gameMenu_case=0;
				ret=-1;
		}
	}
	return ret;
}
