#include "menu.h"
#ifdef _arch_dreamcast
#include <kos.h>
#endif

extern int emulating;

char *text_str_title="VBA32 - Main Menu --";
char *text_str_load="Load Rom";
char *text_str_0="0";
char *text_str_50="50";
char *text_str_100="100";
char *text_str_150="150";
char *text_str_200="200";
char *text_str_1="1";
char *text_str_2="2";
char *text_str_3="3";
char *text_str_4="4";
char *text_str_5="5";
char *text_str_auto="auto";
char *text_str_on="on";
char *text_str_off="off";
char *text_str_120="120";
char *text_str_133="133";
char *text_str_156="156";
char *text_str_166="166";
char *text_str_separator="------------------------------";
char *text_str_save="Game Menu";
char *text_str_control="Control Menu";
char *text_str_exit="Exit - Reboot Dreamcast";

int mainMenu_throttle=200;
int mainMenu_frameskip=-1;
int mainMenu_sound=1;
//int mainMenu_speed=133;
int mainMenu_case=-1;
extern int num_joys;//=0;
extern SDL_Joystick *joys[4];

#ifdef _arch_dreamcast
extern dirent_t *text_dir_files;
#endif

extern char* vba32_rom_path;

enum { MAIN_MENU_CASE_REBOOT, MAIN_MENU_CASE_LOAD, MAIN_MENU_CASE_SAVE, MAIN_MENU_CASE_CONTROL, MAIN_MENU_CASE_CANCEL };

static inline void draw_mainMenu(int c)
{
	static int b=0;
	int bb=(b%6)/3;

	text_draw_background();
	text_draw_window(40,24,260,200,text_str_title);
	write_text(6,4,text_str_separator);
	if ((c==0)&&(bb))
		write_text_inv(6,5,text_str_load);
	else
		write_text(6,5,text_str_load);
	write_text(6,6,text_str_separator);

	write_text(6,8,"Throttle ");
	if ((mainMenu_throttle==0)&&((c!=1)||(bb)))
		write_text_inv(17,8,text_str_0);
	else
		write_text(17,8,text_str_0);
	if ((mainMenu_throttle==50)&&((c!=1)||(bb)))
		write_text_inv(20,8,text_str_50);
	else
			write_text(20,8,text_str_50);
	if ((mainMenu_throttle==100)&&((c!=1)||(bb)))
		write_text_inv(23,8,text_str_100);
	else
		write_text(23,8,text_str_100);
	if ((mainMenu_throttle==150)&&((c!=1)||(bb)))
		write_text_inv(27,8,text_str_150);
	else
		write_text(27,8,text_str_150);
	if ((mainMenu_throttle==200)&&((c!=1)||(bb)))
		write_text_inv(31,8,text_str_200);
	else
		write_text(31,8,text_str_200);

	write_text(6,10,"Frameskip");
	if ((mainMenu_frameskip==0)&&((c!=2)||(bb)))
		write_text_inv(17,10,text_str_0);
	else
		write_text(17,10,text_str_0);
	if ((mainMenu_frameskip==1)&&((c!=2)||(bb)))
		write_text_inv(19,10,text_str_1);
	else
		write_text(19,10,text_str_1);
	if ((mainMenu_frameskip==2)&&((c!=2)||(bb)))
		write_text_inv(21,10,text_str_2);
	else
		write_text(21,10,text_str_2);
	if ((mainMenu_frameskip==3)&&((c!=2)||(bb)))
		write_text_inv(23,10,text_str_3);
	else
		write_text(23,10,text_str_3);
	if ((mainMenu_frameskip==4)&&((c!=2)||(bb)))
		write_text_inv(25,10,text_str_4);
	else
		write_text(25,10,text_str_4);
	if ((mainMenu_frameskip==5)&&((c!=2)||(bb)))
		write_text_inv(27,10,text_str_5);
	else
		write_text(27,10,text_str_5);
	if ((mainMenu_frameskip==-1)&&((c!=2)||(bb)))
		write_text_inv(29,10,text_str_auto);
	else
		write_text(29,10,text_str_auto);

	write_text(6,12,"Sound");
	if ((mainMenu_sound==0)&&((c!=3)||(bb)))
		write_text_inv(13,12,text_str_off);
	else
		write_text(13,12,text_str_off);
	if ((mainMenu_sound!=0)&&((c!=3)||(bb)))
		write_text_inv(18,12,text_str_on);
	else
		write_text(18,12,text_str_on);

/*
	write_text(6,14,"CPU speed");
	if ((mainMenu_speed==100)&&((c!=4)||(bb)))
		write_text_inv(16,14,text_str_100);
	else
		write_text(16,14,text_str_100);
	if ((mainMenu_speed==120)&&((c!=4)||(bb)))
		write_text_inv(20,14,text_str_120);
	else
		write_text(20,14,text_str_120);
	if ((mainMenu_speed==133)&&((c!=4)||(bb)))
		write_text_inv(24,14,text_str_133);
	else
		write_text(24,14,text_str_133);
	if ((mainMenu_speed==156)&&((c!=4)||(bb)))
		write_text_inv(28,14,text_str_156);
	else
		write_text(28,14,text_str_156);
	if ((mainMenu_speed==166)&&((c!=4)||(bb)))
		write_text_inv(32,14,text_str_166);
	else
		write_text(32,14,text_str_166);
*/
	write_text(6,16,text_str_separator);
	if ((c==4)&&(bb))
		write_text_inv(6,17,text_str_save);
	else
		write_text(6,17,text_str_save);
	write_text(6,18,text_str_separator);

	write_text(6,20,text_str_separator);
	if ((c==5)&&(bb))
		write_text_inv(6,21,text_str_control);
	else
		write_text(6,21,text_str_control);
	write_text(6,22,text_str_separator);

	write_text(6,24,text_str_separator);
	if ((c==6)&&(bb))
		write_text_inv(6,25,text_str_exit);
	else
		write_text(6,25,text_str_exit);
	write_text(6,26,text_str_separator);

	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(50);
#endif
	b++;
}

static inline int key_mainMenu(int *cp)
{
	int c=(*cp);
	int end=0;
	int left=0, right=0, up=0, down=0, hit0=0, hit1=0;
	int getleft,getright,getup,getdown,getA,getStart=0;
	int joyleft,joyright,joyup,joydown,joyA,joyStart=0;
	SDL_Event event;

	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
		{
			mainMenu_case=MAIN_MENU_CASE_REBOOT;
			end=-1;
		}
		else
		if (event.type == SDL_KEYDOWN)
		{
			switch(event.key.keysym.sym)
			{
				case SDLK_RIGHT: right=1; break;
				case SDLK_LEFT: left=1; break;
				case SDLK_UP: up=1; break;
				case SDLK_DOWN: down=1; break;
				case SDLK_LCTRL: hit0=1; break;
				case SDLK_LALT: hit1=1; break;
				default: break;
			}
		}
  		else
    	if (event.type == SDL_JOYHATMOTION)
     	{
     		joyup=JOY_HATUP(0);
     		joydown=JOY_HATDOWN(0);
     		joyleft=JOY_HATLEFT(0);
     		joyright=JOY_HATRIGHT(0);
      		if (joyup )//&& !getup)
			{ 		
				up=1;
			}
			getup=joyup;
      		if (joydown )//&& !getdown)
			{ 		
				down=1;
			}
			getdown=joydown;			
      		if (joyleft )//&& !getleft)
			{ 		
				left=1;
			}
			getleft=joyleft;				
      		if (joyright )//&& !getright)
			{ 		
				right=1;
			}
			getright=joyright;		
  		}
  		else
    	if (event.type == SDL_JOYBUTTONDOWN || event.type == SDL_JOYBUTTONUP)
     	{    		
     		joyA=JOY_A(0);
     		joyStart=JOY_START(0);
     		
      		if (joyA )//&& !getA)
			{ 		
				hit0=1;
			}
			getA=joyA;	    
      		if (joyStart )//&& !getStart)
			{ 		
				hit1=1;
			}
			getStart=joyStart; 	
		}
			if (hit1)
			{
				mainMenu_case=MAIN_MENU_CASE_CANCEL;
				end=1;
			}
			else if (up)
			{
				if (c>0) c=(c-1)%7;
				else c=6;
			}
			else if (down)
				c=(c+1)%7;
			else
			switch(c)
			{
				case 0:
					if (hit0)
					{
						mainMenu_case=MAIN_MENU_CASE_LOAD;
						end=1;
					}
					break;
				case 1:
					if (left)
					{
						if (mainMenu_throttle>0)
							mainMenu_throttle-=50;
						else
							mainMenu_throttle=200;
					}
					else if (right)
					{
						if (mainMenu_throttle<200)
							mainMenu_throttle+=50;
						else
							mainMenu_throttle=0;
					}
					break;
				case 2:
					if (left)
					{
						if (mainMenu_frameskip>-1)
							mainMenu_frameskip--;
						else
							mainMenu_frameskip=5;
					}
					else if (right)
					{
						if (mainMenu_frameskip<5)
							mainMenu_frameskip++;
						else
							mainMenu_frameskip=-1;
					}
					break;
				case 3:
					if (left)
					{
						if (mainMenu_sound)
							mainMenu_sound=0;
					}
					else if (right)
					{
						if (!mainMenu_sound)
							mainMenu_sound=1;
					}
					break;
				case 4:
					if (hit0)
					{
						mainMenu_case=MAIN_MENU_CASE_SAVE;
						end=1;
					}
					break;
				case 5:
					if (hit0)
					{
						mainMenu_case=MAIN_MENU_CASE_CONTROL;
						end=1;
					}
					break;
				case 6:
					if (hit0)
					{
						mainMenu_case=MAIN_MENU_CASE_REBOOT;
						end=1;
					}
					break;
			}
		}
	 


	(*cp)=c;
	return end;
}

static inline void raise_mainMenu()
{
	int i;

	text_draw_background();
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(20);
#endif
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(40,(10-i)*24,260,200,text_str_title);
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(10);
#endif
	}
}

static inline void unraise_mainMenu()
{
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(40,(10-i)*24,260,200,text_str_title);
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(10);
#endif
	}
	text_draw_background();
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(20);
#endif
}

static inline void drawNoRun(void)
{
	int i;

	for(i=0;i<20;i++)
	{
		text_draw_background();
		text_draw_window(64,120,160,32,"--- ERROR ---");
		write_text(9,16,"Game not running");
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(20);
#endif
	}
}

int run_mainMenu()
{
	int end,c=0;
	mainMenu_case=-1;
	num_joys = SDL_NumJoysticks();
	joys[0] = SDL_JoystickOpen(0);
	
	while(mainMenu_case<0)
	{
		raise_mainMenu();
		end=0;
		while(!end)
		{
			draw_mainMenu(c);
			end=key_mainMenu(&c);
		}
		unraise_mainMenu();
		switch(mainMenu_case)
		{
			case MAIN_MENU_CASE_LOAD:
				mainMenu_case=run_menuLoad();
					#ifdef _arch_dreamcast
				text_dir_files=NULL;
				#endif
				//strcpy(vba32_rom_path,"/cd");
				break;
			case MAIN_MENU_CASE_CANCEL:
				mainMenu_case=2;
				break;
			case MAIN_MENU_CASE_SAVE:
				if (emulating)
					mainMenu_case=run_menuGame();
				else
				{
					drawNoRun();
					mainMenu_case=-1;
				}
				break;
			case MAIN_MENU_CASE_REBOOT:
				#ifdef _arch_dreamcast
				arch_exit();
				#endif
				//asm("mov        r3,#0; bx       r3;");
				break;
			case MAIN_MENU_CASE_CONTROL:
				mainMenu_case=run_menuControl();
			default:
				mainMenu_case=-1;
		}
	}
	SDL_JoystickClose(0);
	return mainMenu_case;
}
