/*
 * VisualBoyAdvanced - Nintendo Gameboy/GameboyAdvance (TM) emulator
 * Copyrigh(c) 1999-2002 Forgotten (vb@emuhq.com)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
//#include <sys/stat.h>
#ifdef _arch_dreamcast
#include <kos.h>
#include <dc/sound/stream.h>
snd_stream_hnd_t shnd;
void *audio_callback(snd_stream_hnd_t hnd, int samples_requested, int *samples_returned);
#endif
#include "autobuild.h"
#include "gba.h"
#include "globals.h"
#include "flash.h"
#include "port.h"
#include "sound.h"
//#include "gb.h"
//#include "gbGlobals.h"
//#include "getopt.h"
#include "util.h"
#include "rtc.h"
#include "menu.h" 
//#include "Text.h"
char *vba32_rom_path=NULL;
char *vba32_rom_file=NULL;
char *last_dir=NULL;
int dir_depth=0;


int vba32_rom_type=0;

//#include <SDL/SDL.h>

#ifdef __GNUC__
#include <unistd.h>
#define GETCWD getcwd
#else
#include <direct.h>
#define GETCWD _getcwd
#endif

#ifndef __GNUC__
#define HAVE_DECL_GETOPT 0
#define __STDC__ 1
#else
#define HAVE_DECL_GETOPT 1
#endif

#define AUTO_FRAME_MAX 85
#define AUTO_FRAME_MED 80
#define AUTO_FRAME_MIN 80

extern bool soundEcho;
extern bool soundLowPass;
extern bool soundReverse;

extern void CPUUpdateRenderBuffers(bool);
extern void CPUUpdateCPSR();

extern void mainMenu(void);
extern void drawText(u8 *, int, int, int, const char *);
extern void drawTextTransp(u8 *, int, int, int, const char *);

bool (*emuWriteState)(char *) = NULL;
bool (*emuWriteMemState)(char *, int) = NULL;
bool (*emuReadState)(char *) = NULL;
bool (*emuReadMemState)(char *, int) = NULL;
bool (*emuWriteBattery)(char *) = NULL;
bool (*emuReadBattery)(char *) = NULL;
void (*emuReset)() = NULL;
void (*emuCleanUp)() = NULL;
bool (*emuWritePNG)(char *) = NULL;
bool (*emuWriteBMP)(char *) = NULL;
void (*emuMain)(int) = NULL;
void (*emuUpdateCPSR)() = NULL;
int emuCount = 0;
bool emuHasDebugger = false;

//SDL_Surface *surface = NULL;

//static int sdlCalculateShift(u32 mask)
//{
//  int m = 0;
//
//  while(mask) {
//    m++;
//    mask >>= 1;
//  }
//
//  return m-5;
//}
#ifdef _arch_dreamcast
#include "pvrfuncts.h"
//unsigned short   *vidram_buf;
#endif

int systemSpeed = 0;
int systemRedShift = 0;
int systemBlueShift = 0;
int systemGreenShift = 0;
int systemColorDepth = 16;
int systemDebug = 0;
int systemVerbose = 0;
int systemFrameSkip = 0;

int srcPitch = 0;
int srcWidth = 0;
int srcWidth2 = 0;
int srcHeight = 0;

int sensorX = 2047;
int sensorY = 2047;

int filter = 0;
// u8 *delta = NULL;

int disableMMX = 0;

int cartridgeType = 3;
int captureFormat = 0;

int pauseWhenInactive = 0;
int active = 1;
int emulating = 0;
int RGB_LOW_BITS_MASK=0x821;
u32 systemColorMap32[0x10000];
u16 systemColorMap16[0x10000];
u16 systemGbPalette[24];

/*
static char *rewindMemory = NULL;
static int rewindPos = 0;
static int rewindTopPos = 0;
static int rewindCounter = 0;
static int rewindCount = 0;
static bool rewindSaveNeeded = false;
static int rewindTimer = 0;
*/

#define REWIND_SIZE 400000

#define _stricmp strcasecmp

enum {
  KEY_LEFT, KEY_RIGHT,
  KEY_UP, KEY_DOWN,
  KEY_BUTTON_A, KEY_BUTTON_B,
  KEY_BUTTON_START, KEY_BUTTON_SELECT,
  KEY_BUTTON_L, KEY_BUTTON_R,
  KEY_BUTTON_SPEED, KEY_BUTTON_CAPTURE
};

bool sdlButtons[4][12] = {
  { false, false, false, false, false, false,
    false, false, false, false, false, false },
  { false, false, false, false, false, false,
    false, false, false, false, false, false },
  { false, false, false, false, false, false,
    false, false, false, false, false, false },
  { false, false, false, false, false, false,
    false, false, false, false, false, false }
};

bool sdlMotionButtons[4] = { false, false, false, false };

int sdlNumDevices = 0;
//SDL_Joystick **sdlDevices = NULL;

bool wasPaused = false;
int autoFrameSkip = 0;
int frameskipadjust = 0;
int showRenderedFrames = 0;
int renderedFrames = 0;

int throttle = 0;
u32 throttleLastTime = 0;
u32 autoFrameSkipLastTime = 0;

int showSpeed = 0;
int showSpeedTransparent = 0;
bool disableStatusMessages = false;
bool paused = false;
bool pauseNextFrame = false;
int fullscreen = 0;
bool systemSoundOn = false;
bool removeIntros = false;
int sdlFlashSize = 0;
int sdlAutoIPS = 1;
int sdlRtcEnable = 0;
int sdlAgbPrint = 0;

int sdlDefaultJoypad = 0;

int autoFire = 0;
bool autoFireToggle = false;

bool screenMessage = false;
char screenMessageBuffer[21];
u32  screenMessageTime = 0;

//SDL_cond *cond = NULL;
//SDL_mutex *mutex = NULL;
//u8 sdlBuffer[4096];
//int sdlSoundLen = 0;



u16 joypad[4][12] = {
/*  { SDLK_LEFT,  SDLK_RIGHT,
    SDLK_UP,    SDLK_DOWN,
    SDLK_LCTRL,     SDLK_LALT,
    SDLK_RETURN,SDLK_SPACE,
    SDLK_BACKSPACE,     SDLK_TAB,
    SDLK_F11, SDLK_F12
*/
  { //4096,  4097, //joystick  left , right
    //4098,    4099, //joystick  up , down
    4131,	4130, //analog left , right
    4128,	4129, //analog up, down
    4226,     4224, // A button, B Button
    4228,    4227,  // start, select
    4103,    4101,  // left trigger, right trigger
    4225 , 0
  },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

//u16 defaultJoypad[12] = {
//  SDLK_LEFT,  SDLK_RIGHT,
//  SDLK_UP,    SDLK_DOWN,
//  SDLK_z,     SDLK_x,
//  SDLK_RETURN,SDLK_BACKSPACE,
//  SDLK_a,     SDLK_s,
//  SDLK_SPACE, SDLK_F12
//};

u16 motion[4] = {
  //SDLK_KP4, SDLK_KP6, SDLK_KP8, SDLK_KP2
  4096,4097, 4098,4099 //joystick
  //4131,4130,4128,4129 //analog pad
};

//u16 defaultMotion[4] = {
//  SDLK_KP4, SDLK_KP6, SDLK_KP8, SDLK_KP2
//};

extern bool CPUIsGBAImage(char *);
extern bool gbIsGameboyRom(char *);

u32 sdlFromHex(char *s)
{
  u32 value=0;
  //sscanf(s, "%x", &value);
  sprintf((char *)value,"%x",s);
  return value;
}

#ifdef __MSC__
#define stat _stat
#define S_IFDIR _S_IFDIR
#endif

char *sdlGetFilename(char *name)
{
  static char filebuffer[16]="\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

  strncpy((char *)&filebuffer,vba32_rom_file,16);

  char *f= strchr((char *)&filebuffer,'.');

  if (f!=NULL)
	(*f)='\0';

  return filebuffer;
}


void sdlWriteState(int num)
{
  char stateName[32];

  sprintf(stateName, "%s.sg%d", sdlGetFilename(vba32_rom_file), num);
  if(emuWriteState)
    emuWriteState(stateName);
}

void sdlReadState(int num)
{
  char stateName[32];

  sprintf(stateName,"%s.sg%d", sdlGetFilename(vba32_rom_file), num);

  if(emuReadState)
    emuReadState(stateName);
}

void sdlWriteBattery()
{
  char buffer[32];

  sprintf(buffer, "%s.sav", sdlGetFilename(vba32_rom_file));

  emuWriteBattery(buffer);
}

void sdlReadBattery()
{
  char buffer[32];

  sprintf(buffer, "%s.sav", sdlGetFilename(vba32_rom_file));

  bool res = false;

  res = emuReadBattery(buffer);
}

#define MOD_KEYS    (KMOD_CTRL|KMOD_SHIFT|KMOD_ALT|KMOD_META)
#define MOD_NOCTRL  (KMOD_SHIFT|KMOD_ALT|KMOD_META)
#define MOD_NOALT   (KMOD_CTRL|KMOD_SHIFT|KMOD_META)
#define MOD_NOSHIFT (KMOD_CTRL|KMOD_ALT|KMOD_META)

//static inline void sdlUpdateKey(int key, bool down)
//{
//  int i,j;
//  for(j = 0; j < 4; j++) {
//    for(i = 0 ; i < 12; i++) {
//      if((joypad[j][i] & 0xf000) == 0) {
//        if(key == joypad[j][i])
//          sdlButtons[j][i] = down;
//      }
//    }
//  }
//  for(i = 0 ; i < 4; i++) {
//    if((motion[i] & 0xf000) == 0) {
//      if(key == motion[i])
//        sdlMotionButtons[i] = down;
//    }
//  }
//}
//
//void sdlUpdateJoyButton(int which,
//                        int button,
//                        bool pressed)
//{
//  int i;
//  int j;
//  for(j = 0; j < 4; j++) {
//    for(i = 0; i < 12; i++) {
//      int dev = (joypad[j][i] >> 12);
//      int b = joypad[j][i] & 0xfff;
//      if(dev) {
//        dev--;
//
//        if((dev == which) && (b >= 128) && (b == (button+128))) {
//          sdlButtons[j][i] = pressed;
//        }
//      }
//    }
//  }
//  for(i = 0; i < 4; i++) {
//    int dev = (motion[i] >> 12);
//    int b = motion[i] & 0xfff;
//    if(dev) {
//      dev--;
//
//      if((dev == which) && (b >= 128) && (b == (button+128))) {
//        sdlMotionButtons[i] = pressed;
//      }
//    }
//  }
//}
//
//void sdlUpdateJoyHat(int which,
//                     int hat,
//                     int value)
//{
//  int i;
//  int j;
//  for(j = 0; j < 4; j++) {
//    for(i = 0; i < 12; i++) {
//      int dev = (joypad[j][i] >> 12);
//      int a = joypad[j][i] & 0xfff;
//      if(dev) {
//        dev--;
//
//        if((dev == which) && (a>=32) && (a < 48) && (((a&15)>>2) == hat)) {
//          int dir = a & 3;
//          int v = 0;
//          switch(dir) {
//          case 0:
//            v = value & SDL_HAT_UP;
//            break;
//          case 1:
//            v = value & SDL_HAT_DOWN;
//            break;
//          case 2:
//            v = value & SDL_HAT_RIGHT;
//            break;
//          case 3:
//            v = value & SDL_HAT_LEFT;
//            break;
//          }
//          sdlButtons[j][i] = (v ? true : false);
//        }
//      }
//    }
//  }
//  for(i = 0; i < 4; i++) {
//    int dev = (motion[i] >> 12);
//    int a = motion[i] & 0xfff;
//    if(dev) {
//      dev--;
//
//      if((dev == which) && (a>=32) && (a < 48) && (((a&15)>>2) == hat)) {
//        int dir = a & 3;
//        int v = 0;
//        switch(dir) {
//        case 0:
//          v = value & SDL_HAT_UP;
//          break;
//        case 1:
//          v = value & SDL_HAT_DOWN;
//          break;
//        case 2:
//          v = value & SDL_HAT_RIGHT;
//          break;
//        case 3:
//          v = value & SDL_HAT_LEFT;
//          break;
//        }
//        sdlMotionButtons[i] = (v ? true : false);
//      }
//    }
//  }
//}
//
//void sdlUpdateJoyAxis(int which,
//                      int axis,
//                      int value)
//{
//  int i;
//  int j;
//  for(j = 0; j < 4; j++) {
//    for(i = 0; i < 12; i++) {
//      int dev = (joypad[j][i] >> 12);
//      int a = joypad[j][i] & 0xfff;
//      if(dev) {
//        dev--;
//
//        if((dev == which) && (a < 32) && ((a>>1) == axis)) {
//          sdlButtons[j][i] = (a & 1) ? (value > 12) : (value < -12);
//        }
//      }
//    }
//  }
//  for(i = 0; i < 4; i++) {
//    int dev = (motion[i] >> 12);
//    int a = motion[i] & 0xfff;
//    if(dev) {
//      dev--;
//
//      if((dev == which) && (a < 32) && ((a>>1) == axis)) {
//        sdlMotionButtons[i] = (a & 1) ? (value > 12) : (value < -12);
//      }
//    }
//  }
//}
//
//bool sdlCheckJoyKey(int key)
//{
//  int dev = (key >> 12) - 1;
//  int what = key & 0xfff;
//
//  if(what >= 128) {
//    // joystick button
//    int button = what - 128;
//
//    if(button >= SDL_JoystickNumButtons(sdlDevices[dev]))
//      return false;
//  } else if (what < 0x20) {
//    // joystick axis
//    what >>= 1;
//    if(what >= SDL_JoystickNumAxes(sdlDevices[dev]))
//      return false;
//  } else if (what < 0x30) {
//    // joystick hat
//    what = (what & 15);
//    what >>= 2;
//    if(what >= SDL_JoystickNumHats(sdlDevices[dev]))
//      return false;
//  }
//
//  // no problem found
//  return true;
//}
//
//void sdlCheckKeys()
//{
//  sdlNumDevices = SDL_NumJoysticks();
//
//  if(sdlNumDevices)
//    sdlDevices = (SDL_Joystick **)calloc(1,sdlNumDevices *
//                                         sizeof(SDL_Joystick **));
//  int i;
//  int j;
//  bool usesJoy = false;
//
//  for(j = 0; j < 4; j++) {
//    for(i = 0; i < 12; i++) {
//      int dev = joypad[j][i] >> 12;
//      //printf("dev= %d",dev);
//      if(dev) {
//        dev--;
//        bool ok = false;
//
//        if(sdlDevices) {
//          if(dev < sdlNumDevices) {
//            if(sdlDevices[dev] == NULL) {
//              sdlDevices[dev] = SDL_JoystickOpen(dev);
//            }
//
//            ok = sdlCheckJoyKey(joypad[j][i]);
//          } else
//            ok = false;
//        }
//
//        if(!ok)
//          joypad[j][i] = defaultJoypad[i];
//        else
//          usesJoy = true;
//      }
//    }
//  }
//
//  for(i = 0; i < 4; i++) {
//    int dev = motion[i] >> 12;
//    if(dev) {
//      dev--;
//      bool ok = false;
//
//      if(sdlDevices) {
//        if(dev < sdlNumDevices) {
//          if(sdlDevices[dev] == NULL) {
//            sdlDevices[dev] = SDL_JoystickOpen(dev);
//          }
//
//          ok = sdlCheckJoyKey(motion[i]);
//        } else
//          ok = false;
//      }
//
//      if(!ok)
//        motion[i] = defaultMotion[i];
//      else
//        usesJoy = true;
//    }
//  }
//
//  if(usesJoy)
//    SDL_JoystickEventState(SDL_ENABLE);
//}
//
//
//void sdlPollEvents()
//{
//  SDL_Event event;
//  static int tab_pressed=0, backspace_pressed=0;
//  while(SDL_PollEvent(&event)) {
//    switch(event.type) {
//    case SDL_JOYHATMOTION:
//      sdlUpdateJoyHat(event.jhat.which,
//                      event.jhat.hat,
//                      event.jhat.value);
//      break;
//    case SDL_JOYBUTTONDOWN:
//    case SDL_JOYBUTTONUP:
//      sdlUpdateJoyButton(event.jbutton.which,
//                         event.jbutton.button,
//                         event.jbutton.state == SDL_PRESSED);
//     break;
//    case SDL_JOYAXISMOTION:
//      sdlUpdateJoyAxis(event.jaxis.which,
//                       event.jaxis.axis,
//                       event.jaxis.value);
//
//    if( (sdlButtons[event.jbutton.which][KEY_BUTTON_R]) && (sdlButtons[event.jbutton.which][KEY_BUTTON_L]) && (sdlButtons[event.jbutton.which][KEY_BUTTON_START]) )
//    {
//    			sdlButtons[event.jbutton.which][KEY_BUTTON_R]=false;
//    			sdlButtons[event.jbutton.which][KEY_BUTTON_L]=false;
//    			sdlButtons[event.jbutton.which][KEY_BUTTON_START]=false;
//				sdlWriteBattery();
//				snd_stream_stop(shnd);
//				vid_clear(0,0,0);
//				mainMenu();
//				vid_clear(0,0,0);
//				SDL_Init(SDL_INIT_JOYSTICK);
////				snd_stream_reinit(shnd, *audio_callback);
//                snd_stream_start(shnd,44100,1);
//				#ifdef _arch_dreamcast
//				if (cartridgeType != 0) {
//				#endif
//              #ifndef _arch_dreamcast
//              if (cartridgeType == 0) {
//              //surface = SDL_SetVideoMode(srcWidth, srcHeight, 16,SDL_HWSURFACE|SDL_DOUBLEBUF);
//              //pix=(void *)surface->pixels;
//              }
//              else
//              #endif
//              {
//              //surface = SDL_SetVideoMode(srcWidth, srcHeight, 8,SDL_HWSURFACE|SDL_DOUBLEBUF);
//              //pixgb=(void *)surface->pixels;
//              }
//				SDL_ShowCursor(0);
//				#ifdef _arch_dreamcast
//				}
//				else
//				{
//		  		vid_set_mode(DM_320x240, PM_RGB565);
//		  		vid_clear(0,0,0);
//		  		}
//		  		#endif
//				systemDrawScreen();
//		  		sdlReadBattery();
//  				//sdlCheckKeys();
//    }
//      break;
//    case SDL_KEYDOWN:
//      switch(event.key.keysym.sym)
//      {
//		case SDLK_TAB:
//		      tab_pressed=1;
//		      break;
//		case SDLK_BACKSPACE:
//		      backspace_pressed=1;
//		      break;
//		case SDLK_RETURN:
//			if (backspace_pressed && tab_pressed)
//			{
//				sdlWriteBattery();
//				mainMenu();
//				backspace_pressed=0;
//				tab_pressed=0;
//				#ifdef _arch_dreamcast
//				if (cartridgeType != 0) {
//				#endif
//              #ifndef _arch_dreamcast
//              if (cartridgeType == 0) {
//              surface = SDL_SetVideoMode(srcWidth, srcHeight, 16,SDL_HWSURFACE|SDL_DOUBLEBUF);
//              pix=(void *)surface->pixels;
//              }
//              else
//              #endif
//              {
//              surface = SDL_SetVideoMode(srcWidth, srcHeight, 8,SDL_HWSURFACE|SDL_DOUBLEBUF);
//              pixgb=(void *)surface->pixels;
//              }
//				SDL_ShowCursor(0);
//				#ifdef _arch_dreamcast
//				}
//				else
//				{
//		  		vid_set_mode(DM_320x240, PM_RGB565);
//		  		vid_clear(0,0,0);
//		  		}
//		  		#endif
//				systemDrawScreen();
//  				sdlReadBattery();
//  				//sdlCheckKeys();
//			}
//			break;
//		default:
//			break;
//      }
//      sdlUpdateKey(event.key.keysym.sym, true);
//      break;
//    case SDL_KEYUP:
//      switch(event.key.keysym.sym)
//      {
//		case SDLK_TAB:
//		      tab_pressed=0;
//		      break;
//		case SDLK_BACKSPACE:
//		      backspace_pressed=0;
//		      break;
//        default:
//        	break;
//      }
//      sdlUpdateKey(event.key.keysym.sym, false);
//      break;
//    }
//  }
//}

extern int vba32(void);
extern void menuValues(void);

int vba32(void)
{

  int i;
//  vid_set_mode(DM_320x240, PM_RGB565);
  menuValues();

/*
  cpuSaveType = a;
*/

  parseDebug = false;
  systemVerbose = 0;

/*
  if(rewindTimer)
    rewindMemory = (char *)malloc(8*REWIND_SIZE);
*/
  if(sdlFlashSize == 0)
    flashSetSize(0x10000);
  else
    flashSetSize(0x20000);

  rtcEnable(sdlRtcEnable ? true : false);
//  agbPrintEnable(sdlAgbPrint ? true : false);

  for(i = 0; i < 24;) {
    systemGbPalette[i++] = (0x1f) | (0x1f << 5) | (0x1f << 10);
    systemGbPalette[i++] = (0x15) | (0x15 << 5) | (0x15 << 10);
    systemGbPalette[i++] = (0x0c) | (0x0c << 5) | (0x0c << 10);
    systemGbPalette[i++] = 0;
  }

    char *szFile = vba32_rom_file;

    bool failed = false;

    vba32_rom_type = utilFindType(szFile);
    printf("name = %s\n",szFile);
    if(vba32_rom_type == IMAGE_UNKNOWN) {
#ifdef DEBUG
      systemMessage(0, "Unknown file type %s", szFile);
#endif
      return -5;
    }
    cartridgeType = (int)vba32_rom_type;
//    if(vba32_rom_type == IMAGE_GB) {
//      failed = !gbLoadRom(szFile);
//      if(!failed) {
//        cartridgeType = 1;
//        emuWriteState = gbWriteSaveState;
//        emuWriteMemState = gbWriteMemSaveState;
//        emuReadState = gbReadSaveState;
//        emuReadMemState = gbReadMemSaveState;
//        emuWriteBattery = gbWriteBatteryFile;
//        emuReadBattery = gbReadBatteryFile;
//        emuReset = gbReset;
//        emuCleanUp = gbCleanUp;
//        emuWritePNG = gbWritePNGFile;
//        emuWriteBMP = gbWriteBMPFile;
//        emuMain = gbEmulate;
//        emuUpdateCPSR = NULL;
//        emuHasDebugger = false;
//        emuCount = 70000/4;
//        if(sdlAutoIPS) {
////          int size = gbRomSize;
//            extern bool gbUpdateSizes();
//            gbUpdateSizes();
//            gbReset();
//        }
//      }
//    } else
     if (vba32_rom_type == IMAGE_GBA) {
      int size = CPULoadRom(szFile);
      printf("size = %d, name = %s\n",size,szFile);
      failed = (size == 0);
      if(!failed) {
        cartridgeType = 0;
        emuWriteState = CPUWriteState;
        emuWriteMemState = CPUWriteMemState;
        emuReadState = CPUReadState;
        emuReadMemState = CPUReadMemState;
        emuWriteBattery = CPUWriteBatteryFile;
        emuReadBattery = CPUReadBatteryFile;
        emuReset = CPUReset;
        emuCleanUp = CPUCleanUp;
        emuWritePNG = CPUWritePNGFile;
        emuWriteBMP = CPUWriteBMPFile;
        emuMain = CPULoop;
        emuUpdateCPSR = CPUUpdateCPSR;
        emuHasDebugger = true;
        emuCount = 50000;
/*
        if(removeIntros && rom != NULL) {
          WRITE32LE(&rom[0], 0xea00002e);
        }
*/
        CPUInit(NULL, useBios); //biosFileName, useBios);
//	systemFrameSkip=9;
        CPUReset();
/*
        if(sdlAutoIPS) {
          int size = 0x2000000;
        }
*/
      }
    }

    if(failed) {
#ifdef DEBUG
      systemMessage(0, "Failed to load file %s", szFile);
#endif
      return -6;
    }
  sdlReadBattery();

//  sdlCheckKeys();
  if(cartridgeType == 0) {
    srcWidth = 240;
    srcHeight = 160;
    systemFrameSkip = frameSkip;
  } 
//  else if (cartridgeType == 1) {
//    srcWidth = 160;
//    srcHeight = 144;
//    gbBorderLineSkip = 160;
//    gbBorderColumnSkip = 0;
//    gbBorderRowSkip = 0;
//    systemFrameSkip = gbFrameSkip;
//  }
   else {
    srcWidth = 320;
    srcHeight = 240;
  }

  srcWidth2=srcWidth<<1;

//  #ifdef _arch_dreamcast
//  if (cartridgeType != 0) {
//  #else
//  if (cartridgeType == 0) {
//  surface = SDL_SetVideoMode(srcWidth, srcHeight, 16,SDL_HWSURFACE|SDL_DOUBLEBUF);
//  pix=(void *)surface->pixels;
//  }
//  else
//  #endif
//  {
//  surface = SDL_SetVideoMode(srcWidth, srcHeight, 8,SDL_HWSURFACE|SDL_DOUBLEBUF);
//  pixgb=(void *)surface->pixels;
//  }
//  if(surface == NULL) {
//#ifdef DEBUG
//    systemMessage(0, "Failed to set video mode");
//#endif
//    SDL_Quit();
//    return -8;
//  }
//    SDL_ShowCursor(0);
//#ifdef _arch_dreamcast
//}
//else
{
  vid_set_mode(DM_320x240, PM_RGB565);
  vid_clear(0,0,0);

  pvr_setup();

//vidram_buf = (unsigned short *)memalign(32,256*256*2);
}
//#endif
//  systemRedShift = sdlCalculateShift(surface->format->Rmask);
//  systemGreenShift = sdlCalculateShift(surface->format->Gmask);
//  systemBlueShift = sdlCalculateShift(surface->format->Bmask);

//  systemColorDepth = surface->format->BitsPerPixel;

// if(systemColorDepth == 16) {
//    if(cartridgeType == 1) {
//      for(i = 0; i < 0x10000; i++) {
//      systemColorMap16[i] =  ((i & 0x1F) << 10 | (i & 0x3E0) | (i & 0x7C00) >> 10);
////      (((i >> 1) & 0x1f) << 0) | (((i & 0x7c0) >> 6) << 5) | (((i & 0xf800) >> 11) << 11);
//      }
//    } 
//    else
    {
     for(i = 0; i < 0x10000; i++) {
   systemColorMap16[i] = ((i & 0x1F) << 10 | (i & 0x3E0) | (i & 0x7C00) >> 10);
//   ((i & 0x1F) << 11) | ((i & 0x3E0) << 1) | ((i & 0x7C00) >> 10);

      }
    }
    srcPitch = srcWidth * 2+4;

  emulating = 1;
  renderedFrames = 0;
  if(!soundOffFlag)
    soundInit();

  autoFrameSkipLastTime = throttleLastTime = systemGetClock();

//  SDL_WM_SetCaption("VisualBoyAdvance", NULL);

  while(emulating) {
    if(!paused && active) {
        emuMain(emuCount);

/*
        if(rewindSaveNeeded && rewindMemory && emuWriteMemState) {
          rewindCount++;
          if(rewindCount > 8)
            rewindCount = 8;
          if(emuWriteMemState &&
             emuWriteMemState(&rewindMemory[rewindPos*REWIND_SIZE],
                              REWIND_SIZE)) {
            rewindPos = ++rewindPos & 7;
            if(rewindCount == 8)
              rewindTopPos = ++rewindTopPos & 7;
          }
        }

        rewindSaveNeeded = false;
*/
    } else {
//      SDL_Delay(500);
    }
#ifndef _arch_dreamcast
    sdlPollEvents();
#endif    
  }

  emulating = 0;
//  fprintf(stderr,"Shutting down\n");
//  remoteCleanUp();

//  if(gbRom != NULL || rom != NULL) {
  if(rom != NULL) {
    sdlWriteBattery();
    emuCleanUp();
  }
  
   soundShutdown();

  pvr_shutdown(); 
/*
  if(delta) {
    free(delta);
    delta = NULL;
  }
*/
    
//  SDL_Quit();
  return 0;
}

void systemMessage(int num, char *msg, ...)
{
	//printf("SYSTEMMESSAGE - %s\n",&msg);
#ifdef DEBUG
	static int y=0;

	write_text_inv(0,y,msg);
	SDL_Flip(text_screen);
	SDL_Delay(500);

	y=(y+1)%20;
#endif
}

#ifdef _arch_dreamcast
void line_copy_sq(u32 *src, u32 *dst, int count)
{
   unsigned int *d = (unsigned int *)(void *)
      (0xe0000000 | (((unsigned long)dst) & 0x03ffffe0));

   /* Set store queue memory area as desired */
   QACR0 = ((((unsigned int)dst)>>26)<<2)&0x1c;
   QACR1 = ((((unsigned int)dst)>>26)<<2)&0x1c;

   /* fill/write queues as many times necessary */
   count >>= 4;
   while(count--) {
      int v;

      v = *src++;
      v|= *src++<<16;
      d[0] = v;
      v = *src++;
      v|= *src++<<16;
      d[1] = v;
      v = *src++;
      v|= *src++<<16;
      d[2] = v;
      v = *src++;
      v|= *src++<<16;
      d[3] = v;
      v = *src++;
      v|= *src++<<16;
      d[4] = v;
      v = *src++;
      v|= *src++<<16;
      d[5] = v;
      v = *src++;
      v|= *src++<<16;
      d[6] = v;
      v = *src++;
      v|= *src++<<16;
      d[7] = v;

      asm("pref @%0" : : "r" (d));
      d += 8;
   }

   /* Wait for both store queues to complete */
   d = (unsigned int *)0xe0000000;
   d[0] = d[8] = 0;
}

void line_copy_simple(u32 *src, u16 *dst, int count) 
{ 
   while(count--) 
      *dst++ = *src++; 
} 
extern u32 lineMix[240];
extern pvr_ptr_t vidram_tex;
#endif

void renderbuffer()
{

#ifdef _arch_dreamcast
                  u32*dest = vidram_tex + 512 * (VCOUNT+1);
                  line_copy_sq(lineMix, dest, 240); 

#else
                  u16 *dest = (u16 *)pix + 240 /*242*/ * (VCOUNT  /*+1*/);
                  int x;
                   for( x = 0; x < 240;) {
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;

                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;

                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;

                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                    *dest++ = lineMix[x++]&0xFFFF;
                  }
                  // for filters that read past the screen
                  *dest++ = 0;
#endif   
}
extern u32 gbLineMix[160];
//void renderGBbuffer()
//{
//
////                  int x;
//                    u32* dest = vidram_tex + 512*register_LY;//((gbBorderLineSkip) * (register_LY + gbBorderRowSkip) + gbBorderColumnSkip)/2;
////                  line_copy_simple((u32 *)gbLineMix, dest, 160);
//                    line_copy_sq(gbLineMix, dest,160);
//                    //u16 * dest = (u16 *)pixgb + ((gbBorderLineSkip) * (register_LY + gbBorderRowSkip) + gbBorderColumnSkip)/2;
////                    u16 * dest = (u16 *)pixgb +
////(
////                      (gbBorderLineSkip /*+2*/) * (register_LY + gbBorderRowSkip/*+1*/)
////                      + gbBorderColumnSkip
////)/2;
////                    memcpy((void *)dest,&gbLineMix,160);
//
////                    for(x = 0; x < 160; ) {
////                      *dest++ = gbLineMix[x++]&0xFFFF;
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                      *dest++ = systemColorMap16[gbLineMix[x++]];
////                    }
////                    *dest++ = 0; // for filters that read one pixel more
//}
void systemDrawScreen()
{

  renderedFrames++;

//    int destPitch = surface->pitch;
//    printf("destPitch = %d\n",destPitch);
//    u8 *src = (u8*)pix;
//    u8 *dest = (u8*)surface->pixels;
//    int i;
//      src += srcPitch;
//      printf("srcPitch = %d\n",srcPitch);
//      printf("srcHeight = %d, srcWidth2 = %d\n",srcHeight,srcWidth2);
//      for(i = 0; i < srcHeight; i++) {
//        memcpy(dest,src,srcWidth2);
//        src += srcPitch;
//        dest += destPitch;
//      }
//
//  SDL_Flip(surface);


//    int destPitch = 640;
//    u8 *src = (u8*)pix;
//    u8 *dest = (u8*)vram_s;
//    int i;
//      src += srcPitch;
//      for(i = 0; i < srcHeight; i++) {
//        memcpy(dest,src,srcWidth2);
//        src += srcPitch;
//        dest += destPitch;
//      }
//if (cartridgeType != 0) {
//    int destPitch = 512;
//    u8 *src = (u8*)pix;
//    u8 *dest = (u8*)vidram_buf;
//    int i;
//      src += srcPitch;
//      for(i = 0; i < srcHeight; i++) {
//        memcpy(dest,src,srcWidth2);
//        src += srcPitch;
//        dest += destPitch;
//      }
//}
////else
//#ifdef _arch_dreamcast
//if (cartridgeType != 0) {  
//#endif
////SDL_Flip(surface);
//#ifdef _arch_dreamcast
//}
//else
	draw_frame();
//#endif
}

bool systemReadJoypads()
{
  return true;
}

u32 systemReadJoypad(int which)
{
#ifdef _arch_dreamcast
            u32 res = 0;
			cont_cond_t cond;
			uint8	c;
			c = maple_first_controller();
			if (c) {
			   if (cont_get_cond(c, &cond) < 0) {
					printf("Error reading controller\n");
			   }
			   	if (!(cond.buttons &CONT_DPAD_UP)) {
			   		res |= 64;
			   	}
			   	if (!(cond.buttons &CONT_DPAD_DOWN)) {
			   		res |= 128;
			   	}
			   	if (!(cond.buttons &CONT_DPAD_LEFT)) {
			   		res |= 32;
			   	}			   	
			   	if (!(cond.buttons &CONT_DPAD_RIGHT)) {
			   		res |= 16;
			   	}
  			    if(!(cond.buttons & CONT_X))
                {
                	if (autoFire&0x1)
                	{
                		if (autoFireToggle)
                		{
                			res |= 1;
                		}
                	}
                	else
                	{
                		res |= 1;
                	}
                }
                if(!(cond.buttons & CONT_A))
                {
                	if (autoFire&0x2)
                	{
                		if (autoFireToggle)
                		{
                			res |= 2;
                		}
                	}
                  	else
                  	{
                		res |= 2;
                	}
                }                
    			if (!(cond.buttons & CONT_START)) {
    				res |= 8;
    			}
  			    if((cond.rtrig > 0))
                {  res |= 256;}
                
                if((cond.ltrig > 0))
                {  res |= 512;}
                
    			if ((cond.ltrig > 0) &&  (cond.rtrig > 0) && !(cond.buttons & CONT_START)){
    			if(!soundOffFlag)
    			       snd_stream_stop(shnd);
				mainMenu();
                if(!soundOffFlag)
                       snd_stream_start(shnd,44100,1);
                res =0;
                }

			}
			return res;
			

#else
	which=0;
  if(which < 0 || which > 3)
    which = sdlDefaultJoypad;

  u32 res = 0;

  if(sdlButtons[which][KEY_BUTTON_A])
  {
	if (autoFire&0x1)
	{
		if (autoFireToggle)
		{
			res |= 1;
		}
	}
	else
	{
		res |= 1;
	}
  }
  if(sdlButtons[which][KEY_BUTTON_B])
  {
	if (autoFire&0x2)
	{
		if (autoFireToggle)
		{
			res |= 2;
		}
	}
  	else
  	{
		res |= 2;
	}
  }
  if(sdlButtons[which][KEY_BUTTON_SELECT])
  {  res |= 4;}
  if(sdlButtons[which][KEY_BUTTON_START])
  {  res |= 8;}
  if(sdlButtons[which][KEY_RIGHT])
  {  res |= 16;}
  if(sdlButtons[which][KEY_LEFT])
  {  res |= 32;}
  if(sdlButtons[which][KEY_UP])
  {  res |= 64;}
  if(sdlButtons[which][KEY_DOWN])
  {  res |= 128;}
  if(sdlButtons[which][KEY_BUTTON_R])
  {  res |= 256;}
  if(sdlButtons[which][KEY_BUTTON_L])
  {  res |= 512;}
/*
  // disallow L+R or U+D of being pressed at the same time
  if((res & 48) == 48)
    res &= ~16;
  if((res & 192) == 192)
    res &= ~128;

  if(sdlButtons[which][KEY_BUTTON_SPEED])
    res |= 1024;
  if(sdlButtons[which][KEY_BUTTON_CAPTURE])
    res |= 2048;

  if(autoFire) {
    res &= (~autoFire);
    if(autoFireToggle)
      res |= autoFire;
    autoFireToggle = !autoFireToggle;
  }
*/

  autoFireToggle = !autoFireToggle;
  return res;
#endif  
}
void systemShowSpeed(int speed)
{
  systemSpeed = speed;

  showRenderedFrames = renderedFrames;
  renderedFrames = 0;

  if(!fullscreen && showSpeed) {
    char buffer[80];
    if(showSpeed == 1)
      sprintf(buffer, "VisualBoyAdvance-%3d%%", systemSpeed);
    else
      sprintf(buffer, "VisualBoyAdvance-%3d%%(%d, %d fps)", systemSpeed,
              systemFrameSkip,
              showRenderedFrames);
    if(showSpeed == 1)
//    {
//    if(showSpeedTransparent)
//      drawTextTransp((u8*)surface->pixels,
//                     surface->pitch,
//                     10,
//                     surface->h-20,
//                     buffer);
//    else
//      drawText((u8*)surface->pixels,
//               surface->pitch,
//               10,
//               surface->h-20,
//               buffer);
//   }
//   else
   printf("%s\n",buffer);
  }
}

void systemFrame()
{
}
void system10Frames(int rate)
{
  u32 time = systemGetClock();
  if(!wasPaused && autoFrameSkip && !throttle) {
    u32 diff = time - autoFrameSkipLastTime;
    int speed = 100;

    if(diff)
      speed = (1000000/rate)/diff;

    if(speed >= 98) {
      frameskipadjust++;

      if(frameskipadjust >= 3) {
        frameskipadjust=0;
        if(systemFrameSkip > 0)
          systemFrameSkip--;
      }
    } else {
      if(speed  < 80)
        frameskipadjust -= (90 - speed)/5;
      else if(systemFrameSkip < 9)
        frameskipadjust--;

      if(frameskipadjust <= -2) {
        frameskipadjust += 2;
        if(systemFrameSkip < 9)
          systemFrameSkip++;
      }
    }
  }
  if(!wasPaused && throttle) {
    if(!speedup) {
      u32 diff = time - throttleLastTime;

      int target = (1000000/(rate*throttle));
      int d = (target - diff);

      if(d > 0) {
//        SDL_Delay(d);
      }
    }
    throttleLastTime = systemGetClock();
  }

/*
  if(rewindMemory) {
    if(++rewindCounter >= rewindTimer) {
      rewindSaveNeeded = true;
      rewindCounter = 0;
    }
  }
*/

  wasPaused = false;
  autoFrameSkipLastTime = time;
}

/*
void systemScreenCapture(int a)
{
}
*/
u16 sound_buffer[SND_STREAM_BUFFER_MAX] = {0};


#ifndef _arch_dreamcast
void soundCallback(void *nothing,u8 *stream,int len)
{
  if(!emulating)
    return;
  SDL_mutexP(mutex);
  //  printf("Locked mutex\n");
  if(!speedup && !throttle) {
    while(sdlSoundLen < 2048*2) {
      if(emulating)
        SDL_CondWait(cond, mutex);
      else
        break;
    }
  }
  if(emulating) {
    //  printf("Copying data\n");
    memcpy(stream, sdlBuffer, len);
  }
  sdlSoundLen = 0;
  if(mutex)
    SDL_mutexV(mutex);
}
#else
void *audio_callback(snd_stream_hnd_t hnd, int samples_requested, int *samples_returned)
{
    
//    if (soundBufferLen < samples_requested){
//	memcpy(sound_buffer,soundFinalWave,samples_requested);
	*samples_returned = samples_requested;

//	return sound_buffer;
	return soundFinalWave;
}
#endif

void systemWriteDataToSoundBuffer()
{
#ifndef _arch_dreamcast
  if(SDL_GetAudioStatus() != SDL_AUDIO_PLAYING)
    SDL_PauseAudio(0);
  bool cont = true;
  while(cont && !speedup && !throttle) {
    SDL_mutexP(mutex);
    //    printf("Waiting for len < 2048 (speed up %d)\n", speedup);
    if(sdlSoundLen < 2048*2)
      cont = false;
    SDL_mutexV(mutex);
  }

  int len = soundBufferLen;
  int copied = 0;
  if((sdlSoundLen+len) >= 2048*2) {
    //    printf("Case 1\n");
    memcpy(&sdlBuffer[sdlSoundLen],soundFinalWave, 2048*2-sdlSoundLen);
    copied = 2048*2 - sdlSoundLen;
    sdlSoundLen = 2048*2;
    SDL_CondSignal(cond);
    cont = true;
    if(!speedup && !throttle) {
      while(cont) {
        SDL_mutexP(mutex);
        if(sdlSoundLen < 2048*2)
          cont = false;
        SDL_mutexV(mutex);
      }
      memcpy(&sdlBuffer[0],&(((u8 *)soundFinalWave)[copied]),
             soundBufferLen-copied);
      sdlSoundLen = soundBufferLen-copied;
    } else {
      memcpy(&sdlBuffer[0], &(((u8 *)soundFinalWave)[copied]),
soundBufferLen);
    }
  } else {
    //    printf("case 2\n");
    memcpy(&sdlBuffer[sdlSoundLen], soundFinalWave, soundBufferLen);
    sdlSoundLen += soundBufferLen;
  }
#else
    snd_stream_poll(shnd);
#endif
}

bool systemSoundInit()
{
#ifndef _arch_dreamcast
  SDL_AudioSpec audio;

  switch(soundQuality) {
  case 1:
    audio.freq = 44100;
    soundBufferLen = 1470*2;
    break;
  case 2:
    audio.freq = 22050;
    soundBufferLen = 736*2;
    break;
  case 4:
    audio.freq = 11025;
    soundBufferLen = 368*2;
    break;
  }

  audio.format=AUDIO_S16; //SYS;
  audio.channels = 2;
  audio.samples = 1024;
  audio.callback = soundCallback;
  audio.userdata = NULL;
  if(SDL_OpenAudio(&audio, NULL)) {
    printf("Failed to open audio: %s\n", SDL_GetError());
    return false;
  }
  soundBufferTotalLen = soundBufferLen*10;
  cond = SDL_CreateCond();
  mutex = SDL_CreateMutex();
  sdlSoundLen = 0;
#else

    snd_stream_init();
    shnd = snd_stream_alloc(*audio_callback, SND_STREAM_BUFFER_MAX/2);
    snd_stream_start(shnd,44100,1);
#endif
  systemSoundOn = true;
  return true;
}

void systemSoundShutdown()
{
#ifndef _arch_dreamcast
  SDL_mutexP(mutex);
  SDL_CondSignal(cond);
  SDL_mutexV(mutex);
  SDL_DestroyCond(cond);
  cond = NULL;
  SDL_DestroyMutex(mutex);
  mutex = NULL;
  SDL_CloseAudio();
#else
	snd_stream_stop(shnd);
	snd_stream_shutdown();
#endif
}

void systemSoundPause()
{
#ifndef _arch_dreamcast
  SDL_PauseAudio(1);
#else
	if(!soundOffFlag)
    	snd_stream_stop(shnd);
#endif  
}

void systemSoundResume()
{
#ifndef _arch_dreamcast
  SDL_PauseAudio(0);
#else
	if(!soundOffFlag)
	       snd_stream_start(shnd,44100,1);
#endif
}

void systemSoundReset()
{
}


void systemUpdateMotionSensor()
{
  if(sdlMotionButtons[KEY_LEFT]) {
    sensorX += 3;
    if(sensorX > 2197)
      sensorX = 2197;
    if(sensorX < 2047)
      sensorX = 2057;
  } else if(sdlMotionButtons[KEY_RIGHT]) {
    sensorX -= 3;
    if(sensorX < 1897)
      sensorX = 1897;
    if(sensorX > 2047)
      sensorX = 2037;
  } else if(sensorX > 2047) {
    sensorX -= 2;
    if(sensorX < 2047)
      sensorX = 2047;
  } else {
    sensorX += 2;
    if(sensorX > 2047)
      sensorX = 2047;
  }

  if(sdlMotionButtons[KEY_UP]) {
    sensorY += 3;
    if(sensorY > 2197)
      sensorY = 2197;
    if(sensorY < 2047)
      sensorY = 2057;
  } else if(sdlMotionButtons[KEY_DOWN]) {
    sensorY -= 3;
    if(sensorY < 1897)
      sensorY = 1897;
    if(sensorY > 2047)
      sensorY = 2037;
  } else if(sensorY > 2047) {
    sensorY -= 2;
    if(sensorY < 2047)
      sensorY = 2047;
  } else {
    sensorY += 2;
    if(sensorY > 2047)
      sensorY = 2047;
  }
}

int systemGetSensorX()
{
  return sensorX;
}

int systemGetSensorY()
{
  return sensorY;
}

void systemGbPrint(u8 *data,int pages,int feed,int palette, int contrast)
{
}

void systemScreenMessage(char *msg)
{
  screenMessage = true;
  screenMessageTime = systemGetClock();
  if(strlen(msg) > 20) {
    strncpy(screenMessageBuffer, msg, 20);
    screenMessageBuffer[20] = 0;
  } else
    strcpy(screenMessageBuffer, msg);
}

bool systemCanChangeSoundQuality()
{
  return false;
}

bool systemPauseOnFrame()
{
  if(pauseNextFrame) {
    paused = true;
    pauseNextFrame = false;
    return true;
  }
  return false;
}

