#include "pvrfuncts.h"


#include <kos.h>
#include <plx/font.h>

// Parallax Font Stuff
	plx_font_t *fs_fnt;
	plx_fcxt_t *fs_fcxt;

/* textures */
#define TEX_WIDTH 256
#define TEX_HEIGHT 256
pvr_ptr_t vidram_tex;
extern unsigned short   *vidram_buf;
 
void stats() {
	pvr_stats_t stats;
	char temp[100];
	pvr_get_stats(&stats);
	sprintf(temp, "%.2f fps\n",stats.frame_rate);
//	dbglog(DBG_DEBUG, temp);

    plx_fcxt_begin(fs_fcxt);
    plx_fcxt_setpos(fs_fcxt, 0.85f * 20, 0.96f * 20, 15.0f);
    plx_fcxt_draw(fs_fcxt, temp);
    plx_fcxt_end(fs_fcxt);
}


/* init background */
void back_init()
{
    vidram_tex = pvr_mem_malloc(TEX_WIDTH*TEX_HEIGHT*2);
    fs_fnt = plx_font_load("/rd/font.txf");
    fs_fcxt = plx_fcxt_create(fs_fnt, PVR_LIST_TR_POLY);
    plx_fcxt_setsize(fs_fcxt, 16.0f); 

}

/* draw background */
void draw_back()
{
//    dcache_flush_range(vidram_tex, 256*256*2);
//    pvr_txr_load_dma(vidram_buf, vidram_tex, TEX_WIDTH*TEX_HEIGHT*2, 1,NULL,1);
//    pvr_txr_load    (vidram_buf, vidram_tex, TEX_WIDTH*TEX_HEIGHT*2);
    
    float u1=0, v1=0, u2=1,v2=1 /*u2=SCREEN_WIDTH*(1.0f/256.0f), v2=SCREEN_HEIGHT*(1.0f/256.0f)*/, x1=5, y1=25, z1=1, w=320, h=240;
    
    pvr_poly_cxt_t cxt;
    pvr_poly_hdr_t hdr;
    pvr_vertex_t vert;
    
    pvr_poly_cxt_txr(&cxt, PVR_LIST_OP_POLY, PVR_TXRFMT_RGB565|PVR_TXRFMT_NONTWIDDLED, TEX_WIDTH, TEX_HEIGHT, vidram_tex, PVR_FILTER_BILINEAR);
    
    pvr_poly_compile(&hdr, &cxt);
    pvr_prim(&hdr, sizeof(hdr));
    
    vert.argb = PVR_PACK_COLOR(1.0f, 1.0f, 1.0f, 1.0f);
    vert.oargb = 0;
    vert.flags = PVR_CMD_VERTEX;
    
    vert.x = x1;
    vert.y = y1;
    vert.z = z1;
    vert.u = u1;
    vert.v = v1;
    pvr_prim(&vert, sizeof(vert));
    
    vert.x = x1+w;
    vert.y = y1;
    vert.z = z1;
    vert.u = u2;
    vert.v = v1;
    pvr_prim(&vert, sizeof(vert));
    
    vert.x = x1;
    vert.y = y1+h;
    vert.z = z1;
    vert.u = u1;
    vert.v = v2;
    pvr_prim(&vert, sizeof(vert));
    
    vert.x = x1+w;
    vert.y = y1+h;
    vert.z = z1;
    vert.u = u2;
    vert.v = v2;
    vert.flags = PVR_CMD_VERTEX_EOL;
    pvr_prim(&vert, sizeof(vert));

}


/* draw one frame */
void draw_frame()
{
    pvr_wait_ready();
    pvr_scene_begin();

    pvr_list_begin(PVR_LIST_OP_POLY);

    draw_back();
    stats();
    pvr_list_finish();

    pvr_scene_finish();

}

void pvr_setup()
{

    /* init kos  */
    pvr_init_defaults();
    pvr_dma_init();

    /* init background */
    back_init();
}
